#ifndef SEMAPHOREH
#define SEMAPHOREH 

/* Semaphore.h -- declarations for Semaphore

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Object.h"
#include "LinkedList.h"

extern Class class_Semaphore;

class Semaphore: public Object {
	LinkedList waitList;
	short count;
public:
	Semaphore(int initialCount =0)	{ count = initialCount; }
	~Semaphore();
	Semaphore(fileDescTy&,Semaphore&);
	Semaphore(istream&,Semaphore&);
	virtual void deepenShallowCopy();
	virtual UNSIGNED hash();
	virtual const Class* isA();
	virtual bool isEqual(const Object& ob);
	virtual void printOn(ostream& strm);
	virtual obid shallowCopy();	// shouldNotImplement
	virtual void signal();		// signal waiting process 
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
	virtual int value();		// read semaphore value 
	virtual void wait();		// wait on semaphore 
};

#endif
