#ifndef STACKH
#define STACKH

/* Stack.h -- declarations for class Stack

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "OrderedCltn.h"

extern Class class_Stack;

class Stack : public SeqCltn {
	OrderedCltn contents;
public:
	Stack(UNSIGNED size =CLTN_DEFAULT_CAPACITY) : contents(size) {}
	Stack(const Stack& s) : contents(*((OrderedCltn*)&s)) {}
	Stack(fileDescTy&,Stack&);
	Stack(istream&,Stack&);
	bool operator==(const Stack& s)
		{ return contents == ((Stack*)&s)->contents; }
	bool operator!=(const Stack& s)	{ return !(*this==s); }
	void operator=(const Stack& s)	{ contents = ((Stack*)&s)->contents; }
	obid& operator[](int i)		{ return contents.at(size()-i-1); }
	void push(const Object& ob)	{ contents.addLast(ob); }
	obid pop()			{ return contents.removeLast(); }
	obid top()			{ return contents.last(); }
	virtual obid add(const Object& ob);
	virtual Collection& addContentsTo(Collection& cltn);
	virtual obid& at(int i);
	virtual UNSIGNED capacity();
	virtual void deepenShallowCopy();
	virtual UNSIGNED hash();
	virtual const Class* isA();
	virtual bool isEmpty();
	virtual bool isEqual(const Object& ob);
	virtual obid last();
	virtual void printOn(ostream& strm);
	virtual void reSize(UNSIGNED newSize);
	virtual obid removeLast();
	virtual UNSIGNED size();
	virtual const Class* species();
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
};

#endif
