#include "Stack.h"
#include "Exception.h"
#include "oopserrs.h"

void xtrap(unsigned& err, int& sev)
{
	cerr << "xtrap(" << err << "," << sev << ") called\n";
}

class MyClass : public Object {
	int n;
	Catch catch;
public:
	MyClass(int i) : catch(this) {
		n = i;
		cerr << "MyClass(" << n << ") constructed\n";
	}
	virtual void destroyer() {
		cerr << "MyClass(" << n << ") destroyed\n";
	}
};

main()
{
	cerr << "Test classes Catch, ExceptionAction, and ExceptionTrap\n";
	Stack s;
	MyClass* p = new MyClass(-1);
	MyClass* q = new MyClass(-2);
	{
		MyClass a(1);
		MyClass b(2);
		RaiseException x(OOPS__CLTNEMPTY);
		BEGINX
			MyClass c(3);
			MyClass d(4);
			{
				MyClass e(5);
				MyClass f(6);
				delete p;
				s.pop();
			}
		EXCEPTION
			case OOPS__CLTNEMPTY: {
				MyClass g(7);
				MyClass h(8);
				cerr << "CLTNEMPTY error handled\n";
			}
		ENDX
	}
	delete q;
	{
		ExceptionTrap x(xtrap);
		s.pop();
	}
}
